#include "B.h"

using namespace cv;
using namespace std;

void B::write(cv::FileStorage& fs)  const                       //Write serialization for this class
{
	int i=0;
	for ( auto  iti = entier.begin();iti!=entier.end();iti++,i++)
	{
		char tmp[256];
		sprintf(tmp,"%d",i);
		String s("keyInt");
		s += tmp;
		fs<<s<<iti->first;
		s= "ValueInt";
		s += tmp;
		fs<<s<<iti->second;
		}
	i=0;
	for ( auto  iti = reel.begin();iti!=reel.end();iti++,i++)
	{
		char tmp[256];
		sprintf(tmp,"%d",i);
		String s("keyReel");
		s += tmp;
		fs<<s<<iti->first;
		s= "ValueReel";
		s += tmp;
		fs<<s<<iti->second;
	}
}

void B::read(const cv::FileNode& node)                          //Read serialization for this class
{
	char tmp[256];
	int i=0,val;
	double x;
	String s,key;
	do
	{
		sprintf(tmp,"%d",i);
		s="keyInt";
		s += tmp;
		if(!node[s].empty())
		{
			key=(string)node[s];
			s= "ValueInt";
			s += tmp;
			if(!node[s].empty())
			{
				val=(int)node[s];
				entier[key]=val;
			}
		}
	}
	while (!node[s].empty());
	do
	{
		sprintf(tmp,"%d",i);
		s="keyReel";
		s += tmp;
		if(!node[s].empty())
		{
			key=(string)node[s];
			s= "ValueReel";
			s += tmp;
			if(!node[s].empty())
			{
				x=(double)node[s];
				entier[key]=val;
			}
		}
	}
	while (!node[s].empty());

}

static void write(FileStorage& fs, const std::string&, const B& x)
{
    x.write(fs);
}
static void read(const FileNode& node, B& x, const B& default_value = B()){
    if(node.empty())
        x = default_value;
    else
        x.read(node);
}

ostream& operator<<(ostream& out, const B& m)
{
    out << "{  " << 2 << ", ";
    out << "X = " <<3 << ", ";
    out << "A = " << 4 << "}";
    return out;
}
